<?php 


Yii::app()->getClientScript()->registerCoreScript('jquery');

if ( !isset($noedit) )
    $noedit = false;

if ( !isset($nomedia) )
    $nomedia = $noedit;

if ( !$nomedia )
    echo CHtml::beginForm( );


if ($title!="") {
    $title .= " : " . CHtml::tag("span", array( 'class'=>'playlist-name file-name-display'), $feeds->name);
    $title .= " " . CHtml::image( 'images/edit.png', 'Edit', array('class'=>'renamefile file-name-display'));
    $title .= Chtml::tag("span", array( 'class'=>'file-name-rename hidden' ),  
                                CHtml::textField('rename', $feeds->name, array( 'class'=>'file-name-att', 'disabled'=>'disabled')) . " " .
                                CHtml::imageButton("images/cancel.png", array("name"=>"Cancel"))
                        );
    echo CHtml::tag("h2", array("id"=>"main_title"), $title );
}


$entries = $feeds->getEntry();
$data = $feeds->getData();

if ( count($data)==0 ) {
    $data[] = array();
}
    

if ( !$nomedia  )
    echo CHtml::openTag("table", array( "class"=>"two_column_large" ) ) . CHtml::openTag("tr" ) . CHtml::openTag("td", array("class"=>'left_column') );

echo CHtml::openTag( "div", array( 'class'=>'yiiForm' ) );

echo CHtml::openTag( "table", array( 'class'=>"dataGrid" ) );

global $nb_media;
if (!isset($nb_media) )$nb_media = 0;

foreach ($data as $i => $item ) {
    echo CHtml::openTag("tr", array( "class"=>($i%2 ? 'even' : 'odd')." item", "id"=>"item_$i" ) );
    echo CHtml::openTag("td");
    echo CHtml::openTag("div", array("class"=>"simple_small"));
    
    foreach ($entries as $j => $entry) {
        $k = $i."_".$j;
        if ( isset($item[ $entry->element ]) )
            $entry->value = $item[ $entry->element ];
        else
            $entry->value = "";
        
        $htmloptions = array();
        if ( $noedit ) 
            $htmloptions['disabled']='disabled';
            
        echo CHtml::activeLabel( $entry, "value" );
        if ( isset($feedsid) )
            $name = "data[$feedsid][$i][$entry->element]";
        else
            $name = "data[$i][$entry->element]";
            
        
        echo CHtml::openTag("div", array("id"=>"div_{$i}_{$entry->element}"));
        if ( $entry->type=="ltext") {
            $htmloptions['name']=$name ;
            $htmloptions['class']="long_text";
            echo CHtml::activeTextArea( $entry, "value", $htmloptions );
        }elseif ( $entry->type=="audio" || $entry->type=="video" || $entry->type=="image" || $entry->type=="animation") {
            $target = null; 
            $t = $entry->type;
            if ( $entry->type=="animation" ){
                $check = array( $audio, $video, $image, $project, $playlist);
                $t = 'template';
            }else {
                $check = array( $$t );
            }
            foreach ( $check as $src ) if ( is_array($src) )
                foreach ( $src as $media ) 
                    if ( $media->linkpathTemplate == $entry->value ){
                        $target = $media;
                        break;
                    }
            if ( $target==null ) {
                $target = new FileItem(array('type'=>$t, 'name'=>'none'));
            }
            
            echo CHtml::activeHiddenField( $entry, "[$i]value", array('id'=>"media_link_{$k}", 'name'=>$name) );
            
               
            $htmloptions['class']='media_name slide-text droppable';
            $htmloptions['id']="media_name_{$k}";   
            echo CHtml::textField( "medianame", $target->name, $htmloptions ) ." ";
            
            $htmloptions['class']='media_preview droppable';
            $htmloptions['id']="media_prev_{$k}"; 
            
            echo CHtml::image($target->webpathPreview, "Preview", $htmloptions );
            
            $htmloptions['class']='media_select hidden';
            $htmloptions['id']="media_sel__{$k}";
            $htmloptions['onclick']="addSelectedItem(this)";
            echo CHtml::image("images/arrow_in.png", "select", $htmloptions );
            
            $nb_media++;
        } else {
            $htmloptions['name']=$name ;
            $htmloptions['class']="simple_text";
            echo CHtml::activeTextField( $entry, "value", $htmloptions );
        }
        
        echo CHtml::closeTag("div")."\n";
    }    
    echo CHtml::closeTag("div")."\n";
    
    echo CHtml::openTag( "div", array( 'class'=>'action' ) );
    if ( !$noedit) {
        echo CHtml::image("images/delete.png", "Delete", array( 
            "onclick" => "removeEntry(this)",
            'class'=> 'feeds_icon'
            ) ) ." ";
        echo CHtml::image("images/up.png", "Up", array( 
                    "onclick" => "moveUpEntry(this)",
                    'class'=> 'feeds_icon'
                    ) )." ";
        echo CHtml::image("images/down.png", "Down", array( 
                    "onclick" => "moveDownEntry(this)",
                    'class'=> 'feeds_icon'
                    ) );
        
        
    }
    echo CHtml::closeTag("div")."\n";
    
    echo CHtml::closeTag("td");
    echo CHtml::closeTag("tr")."\n";
}

echo CHtml::closeTag( "table" );

if ( !$noedit) {
    echo CHtml::image("images/add_large.png", "Add", array( 
                        'class'=> 'feeds_icon_add',
                        "onclick" => "addEntry()",
                        "title" => ""
                        ) );
                        
    echo CHtml::openTag( "div", array( 'class'=>'action_small' ) );
    if ( isset($savebutton) ){
        echo CHtml::submitButton(Yii::t('app','OK'), array("submit"=>"", "params"=>array("action"=>"Save")))." ";  
        echo CHtml::submitButton(Yii::t('app','Cancel'), array("submit"=>"", "params"=>array("action"=>"Cancel")))." ";  
        
        echo CHtml::closeTag( "div" )."\n";
        echo CHtml::openTag( "div" , array( 'class'=>'action_small' ) );    
        echo CHtml::submitButton(Yii::t('app','Save as'), array("submit"=>"", "params"=>array("action"=>"SaveAs") )). " "; 
        $feeds->name = "";
        echo CHtml::activeTextField( $feeds, 'name' ); 
    }
    echo CHtml::closeTag( "div" )."\n";
}

echo CHtml::closeTag( "div" )."\n";


if ( !$nomedia ) {    
    echo CHtml::closeTag("td");
    // The media files
    
    // the media selection dialog
    $pages = array( ); 
    $sources = array(   Yii::t('app','Images') => $image, 
                        Yii::t('app','Videos') => $video,  
                        Yii::t('app','Audio') => $audio, 
                        Yii::t('app','Hypermedia') => $project, 
                        Yii::t('app','Playlists') => $playlist, 
                    );
    foreach ($sources as $name => $data) {
        if ( isset($data) && is_array($data) && count($data)>0 ) {
            
            ob_start();
            $nb_item = 1;
            if ( $data[0]->type=='image' ) $nb_item = 3;
            $this->widget('MediaView',array('data' => $data, 'actions'=>true , 'nb_items'=>$nb_item, 'width'=>90) );
            $widget_content = ob_get_contents();
            ob_end_clean();
            $pages[$name] =array( 'content' => $widget_content, 'id'=>'media_selection_'.$name  );                    
        }
    }
    
    
    echo CHtml::openTag("td", array( 'class'=>'right_column basic_tabs', 'id'=>'media_file_cell') );
     
    if ( $nb_media>0  ) {
        echo CHtml::openTag("div", array( 'class'=>'yiiForm') );

        echo CHtml::tag("h2", array(), Yii::t('app',"Media files") );

        echo CHtml::tag("br");

        echo CHtml::openTag("div", array('id'=>'media_file') );

        $this->widget('CJuiTabsExt',array(
            'theme'=>'spxfusion',
            'tabs' => $pages
            )
        );
        echo CHtml::closeTag("div");
        echo CHtml::closeTag("div"); //yiiForm
    }
    echo CHtml::closeTag("td");
    
    echo CHtml::closeTag("tr");
    echo CHtml::closeTag("table");

?>
<script type="text/javascript">
/*<![CDATA[*/

var current_idx = -1;
var current_fileId ="";
var current_fileName ="";
var current_previewPath ="";
$(function() {
    $(".draggable").draggable({
        connectToSortable: '#sortable',
        helper: 'clone',
        revert: 'invalid',
        start: function(event, ui) { $('.add_icon',ui.helper ).hide(); },
        //stop: function(event, ui) { $('.add_icon',ui.helper ).show(); }
    });
    $( ".droppable" ).droppable( {
        hoverClass: "ui-state-active",
        drop: function( event, ui ) {
                var fileName=$(".file-name", ui.draggable).text();   
                var fileId=$(".file-id", ui.draggable).text(); 
                var previewPath=$(".preview-path", ui.draggable).text();
                var linkpath=$(".link-path", ui.draggable).text();
                
                current_idx = $(this).attr('id').substr(11);

                addNewItem( fileName, fileId, previewPath, linkpath );
            }
        }
    );
});


    
function addNewItem( fileName, fileId, previewPath, linkpath ) {
    //$('#media_selection').hide();
    if ( current_idx!=-1 ) { 
        var node = $('#media_id___'+current_idx);
        if ( node ) node.attr('value', fileId);
        
        node = $('#media_name_'+current_idx);
        if ( node ) node.attr('value', fileName);
        
        node = $('#media_prev_'+current_idx);
        if ( node ) node.attr('src', previewPath);
        
        node = $('#media_link_'+current_idx);
        if ( node ) node.attr('value', linkpath);
        
        current_idx = -1;
    } else {
        current_fileId = fileId;
        current_fileName = fileName;
        current_previewPath = previewPath;
        current_linkpath = linkpath;
        $(".media_select").show();
        $('.add_icon').hide();
    }
    
}
function addSelectedItem( node ) {
    current_idx = $(node).attr('id').substr(11);
    addNewItem( current_fileName, current_fileId, current_previewPath, current_linkpath );
    $('.add_icon').show();
    $('.media_select').hide();
}

 /*]]>*/
</script>
    
<?php
}    
if ( !$nomedia )
    echo CHtml::endForm();
    
?>


<script type="text/javascript">
    /*<![CDATA[*/

    function menu( idx, name ) {
        $('#div_'+idx+'_'+name).children(".hideThis").hide().attr('disabled', 'disabled'); 
        $('#select_'+idx+'_'+name+'_'+$('#select_'+idx+'_'+name+'_type').val()).show().attr('disabled', '');
    }
    var nbEntry = <?php echo $i+1; ?>;
    // Add the event to button
    function addEntry() {
      // Clone the first div
      var divCloned = $('#item_0').clone();
      // attach the clone to the end
      $('#item_'+(nbEntry-1)).after(divCloned);
      
      // reset all the class
      divCloned.find('input').each( function(index) { this.value = ""; } );
      divCloned.find('.media_preview').each( function(index) { this.src = ""; } );
      
      divCloned.find('textArea').each( function(index) { this.innerHTML = "";  } );
      
      fixIds( );

    };
    
    function fixIds() {
        nbEntry = 0;
        $('.item').each( function(index) {
            this.id = this.id.replace(/\d+/, index);
            if (index%2)
                this.setAttribute('class', 'odd item');
            else
                this.setAttribute('class', 'even item');
            $(this).find('input').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
                this.name = this.name.replace(/\d+/, index);
            });
            $(this).find('img').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
            });
            $(this).find('div').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
            });
               
            $(this).find('textArea').each( function(idx2) {
                this.id = this.id.replace(/\d+/, index);
                this.name = this.name.replace(/\d+/, index);
            });             
            nbEntry++;            
        });
    }
    
    function removeEntry( item ) {
        var row = $(item).parent().parent().parent();
        if ( nbEntry!=1 ) 
           row.remove();
        else {
            row.find(':text').each( function(index) { this.value = ""; this.setAttribute('class', ''); } );
            row.find('select').each( function(index) { this.value = ""; } );
            row.find('textArea').each( function(index) { this.innerHTML = ""; this.setAttribute('class', ''); } );
        }
        
        fixIds( );
    }
    function moveUpEntry( item ) {
        var row = $(item).parent().parent().parent();
        var previous = row.prev();
        if (previous!=null)
            previous.before(row)
        fixIds( );
    }
    function moveDownEntry( item ) {
        var row = $(item).parent().parent().parent();
        var next = row.next();
        if (next!=null)
            next.after(row)
        fixIds( );
    }
    fixIds();
    
    $('.renamefile').click(function(){
        var cell= $(this).parent();
        $( ".file-name-display", cell ).hide();
        $( ".file-name-rename", cell ).show();
        $( ".file-name-att", cell).attr("disabled","");
        return false;
    });
    $("input[name=Cancel]").click(function() {
        var cell= $(this).parent().parent();
        $( ".file-name-display", cell ).show();
        $( ".file-name-rename", cell ).hide();
        $( ".file-name-att", cell).attr("disabled","disabled");
        return false;
    });
   /*]]>*/
</script>
